<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/Comments/Filter.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/Comments/Filter.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/Comments/Filter.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2005 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Processor</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">import</span> re</span>
<a id="line11"></a><span class="lineno"> 11</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/Filter.html">Filter</a>(Processor, ASG.Visitor):</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Base class for comment filters.&quot;&quot;&quot;</span></span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/Filter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> ir.asg.declarations:</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">            d.accept(self)</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/Filter.html#visit_declaration">visit_declaration</a>(self, decl):</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">        comments = decl.annotations.get(<span class="py-string">'comments'</span>, [])</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        comments[:] = [c <span class="py-keyword">is</span> <span class="py-keyword">not</span> None <span class="py-keyword">and</span> self.filter_comment(c) <span class="py-keyword">or</span> None</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">                       <span class="py-keyword">for</span> c <span class="py-keyword">in</span> comments]</span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">    visit_builtin = visit_declaration</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/Filter.html#filter_comment">filter_comment</a>(self, comment):</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Filter comment.&quot;&quot;&quot;</span></span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        <span class="py-keyword">return</span> comment</span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/CFilter.html">CFilter</a>(Filter):</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A class that filters C-style comments.&quot;&quot;&quot;</span></span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">    comment = <span class="py-string">r'/[\*]+[ \t]*(?P&lt;text&gt;.*)(?P&lt;lines&gt;(\n[ \t]*.*)*?)(\n[ \t]*)?[\*]+/'</span></span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">    <span class="py-comment"># Match lines with and without asterisk.</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">    <span class="py-comment"># Preserve space after asterisk so empty lines are formatted correctly.</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">    line = <span class="py-string">r'\n[ \t]*([ \t]*[\*]+(?=[ \t\n]))*(?P&lt;text&gt;.*)'</span></span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/CFilter.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Compiles the regular expressions&quot;&quot;&quot;</span></span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        Filter.__init__(self, **kwds)</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        self.comment = re.compile(CFilter.comment)</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">        self.line = re.compile(CFilter.line)</span>
<a id="line55"></a><span class="lineno"> 55</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/CFilter.html#filter_comment">filter_comment</a>(self, comment):</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Finds comments in the C format. The format is  /* ... */.</span></span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="py-string">        It has to cater for all five line forms: &quot;/* ...&quot;, &quot; * ...&quot;, &quot; ...&quot;,</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><span class="py-string">        &quot; */&quot; and the one-line &quot;/* ... */&quot;.</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        text = []</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        mo = self.comment.search(comment)</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        <span class="py-keyword">while</span> mo:</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">            text.append(mo.group(<span class="py-string">'text'</span>))</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">            lines = mo.group(<span class="py-string">'lines'</span>)</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">            <span class="py-keyword">if</span> lines:</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">                mol = self.line.search(lines)</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">                <span class="py-keyword">while</span> mol:</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">                    text.append(mol.group(<span class="py-string">'text'</span>))</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">                    mol = self.line.search(lines, mol.end())</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            mo = self.comment.search(comment, mo.end())</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'\n'</span>.join(text)</span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSFilter.html">SSFilter</a>(Filter):</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A class that selects only // comments.&quot;&quot;&quot;</span></span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">    ss = <span class="py-string">r'^[ \t]*// ?(.*)$'</span></span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSFilter.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        <span class="py-string">&quot;Compiles the regular expressions&quot;</span></span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">        Filter.__init__(self, **kwds)</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        self.ss = re.compile(SSFilter.ss, re.M)</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSFilter.html#filter_comment">filter_comment</a>(self, comment):</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line90"></a><span class="lineno"> 90</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'\n'</span>.join(self.ss.findall(comment))</span>
<a id="line92"></a><span class="lineno"> 92</span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSDFilter.html">SSDFilter</a>(Filter):</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A class that selects only //. comments.&quot;&quot;&quot;</span></span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">    ssd = <span class="py-string">r'^[ \t]*//\. ?(.*)$'</span></span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSDFilter.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">        <span class="py-string">&quot;Compiles the regular expressions&quot;</span></span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">        Filter.__init__(self, **kwds)</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        self.ssd = re.compile(SSDFilter.ssd, re.M)</span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSDFilter.html#filter_comment">filter_comment</a>(self, comment):</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line108"></a><span class="lineno">108</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'\n'</span>.join(self.ssd.findall(comment))</span>
<a id="line110"></a><span class="lineno">110</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSSFilter.html">SSSFilter</a>(Filter):</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A class that selects only /// comments.&quot;&quot;&quot;</span></span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">    sss = <span class="py-string">r'^[ \t]*/// ?(.*)$'</span></span>
<a id="line116"></a><span class="lineno">116</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSSFilter.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">        <span class="py-string">&quot;Compiles the regular expressions&quot;</span></span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        Filter.__init__(self, **kwds)</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">        self.sss = re.compile(SSSFilter.sss, re.M)</span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/SSSFilter.html#filter_comment">filter_comment</a>(self, comment):</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'\n'</span>.join(self.sss.findall(comment))</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span>
<a id="line130"></a><span class="lineno">130</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/QtFilter.html">QtFilter</a>(Filter):</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A class that finds Qt style comments. These have two styles: //! ...</span></span>
<a id="line132"></a><span class="lineno">132</span><span class="line"><span class="py-string">    and /*! ... */. The first means &quot;brief comment&quot; and there must only be</span></span>
<a id="line133"></a><span class="lineno">133</span><span class="line"><span class="py-string">    one. The second type is the detailed comment.&quot;&quot;&quot;</span></span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">    brief = <span class="py-string">r&quot;[ \t]*//!(.*)&quot;</span></span>
<a id="line136"></a><span class="lineno">136</span><span class="line">    detail = <span class="py-string">r&quot;[ \t]*/\*!(.*)\*/[ \t\n]*&quot;</span></span>
<a id="line137"></a><span class="lineno">137</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/QtFilter.html#__init__">__init__</a>(self, **kwds):</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">        <span class="py-string">&quot;Compiles the regular expressions&quot;</span></span>
<a id="line140"></a><span class="lineno">140</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        Filter.__init__(self, **kwds)</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        self.brief = re.compile(QtFilter.brief)</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">        self.detail = re.compile(QtFilter.detail, re.S)</span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/QtFilter.html#filter_comment">filter_comment</a>(self, comment):</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">        <span class="py-string">&quot;Matches either brief or detailed comments.&quot;</span></span>
<a id="line148"></a><span class="lineno">148</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">        mo = self.brief.match(comment)</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">        <span class="py-keyword">if</span> mo:</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">            <span class="py-keyword">return</span> mo.group(1)</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">            mo = self.detail.match(comment)</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">            <span class="py-keyword">if</span> mo:</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">                <span class="py-keyword">return</span> mo.group(1)</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span>
<a id="line159"></a><span class="lineno">159</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/JavaFilter.html">JavaFilter</a>(Filter):</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A class that selects java /** style comments&quot;&quot;&quot;</span></span>
<a id="line161"></a><span class="lineno">161</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">    java = <span class="py-string">r'/\*\*[ \t]*(?P&lt;text&gt;.*)(?P&lt;lines&gt;(\n[ \t]*\*.*)*?)(\n[ \t]*)?\*/'</span></span>
<a id="line163"></a><span class="lineno">163</span><span class="line">    line = <span class="py-string">r'\n[ \t]*\*[ \t]*(?P&lt;text&gt;.*)'</span></span>
<a id="line164"></a><span class="lineno">164</span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/JavaFilter.html#__init__">__init__</a>(self):</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        <span class="py-string">&quot;Compiles the regular expressions&quot;</span></span>
<a id="line168"></a><span class="lineno">168</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">        self.java = re.compile(JavaFilter.java)</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">        self.line = re.compile(JavaFilter.line)</span>
<a id="line171"></a><span class="lineno">171</span>
<a id="line172"></a><span class="lineno">172</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Processors/Comments/Filter/JavaFilter.html#filter_comment">filter_comment</a>(self, comment):</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Finds comments in the java format. The format is  /** ... */, and</span></span>
<a id="line175"></a><span class="lineno">175</span><span class="line"><span class="py-string">      it has to cater for all four line forms: &quot;/** ...&quot;, &quot; * ...&quot;, &quot; */&quot; and</span></span>
<a id="line176"></a><span class="lineno">176</span><span class="line"><span class="py-string">      the one-line &quot;/** ... */&quot;.</span></span>
<a id="line177"></a><span class="lineno">177</span><span class="line"><span class="py-string">      &quot;&quot;&quot;</span></span>
<a id="line178"></a><span class="lineno">178</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">      text_list = []</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">      mo = self.java.search(comment)</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">      <span class="py-keyword">while</span> mo:</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">         text_list.append(mo.group(<span class="py-string">'text'</span>))</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">         lines = mo.group(<span class="py-string">'lines'</span>)</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">         <span class="py-keyword">if</span> lines:</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">            mol = self.line.search(lines)</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">            <span class="py-keyword">while</span> mol:</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">               text_list.append(mol.group(<span class="py-string">'text'</span>))</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">               mol = self.line.search(lines, mol.end())</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">         mo = self.java.search(comment, mo.end())</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">      <span class="py-keyword">return</span> <span class="py-string">'\n'</span>.join(text_list)</span>
<a id="line191"></a><span class="lineno">191</span>
<a id="line192"></a><span class="lineno">192</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
